<template>
  <div>
    <template>
      <template v-if="isLogged">
        <v-overlay :value="isLoading && !isErrorAccess">
          <v-progress-circular indeterminate size="64"></v-progress-circular>
        </v-overlay>
        <template v-if="!isLoading">
          <template v-if="isErrorAccess">
            <Error401 />
          </template>
          <template v-else>
            <LoggedLayOut />
          </template>
        </template>
      </template>
      <template v-else>
        <router-view />
      </template>
    </template>
  </div>
</template>
<style>
@import "./assets/css/estilos.css";
@import "./assets/css/custom-vuetify.css";
</style>
<style>
.theme--light.v-skeleton-loader .v-skeleton-loader__image {
  background: rgb(250, 249, 249) !important;
}
.v-messages {
  text-align: right;
  top: 0px;
  position: relative;
}
.ponderacion-input > .v-input__control > .v-input__slot:before {
  border: none;
}
.ponderacion-input > .v-input__control > .v-input__slot > .v-text-field__slot {
  border: 2px solid #ffcc00 !important;
}
.theme--light.v-application {
  background: inherit !important;
}
.v-application {
  font-family: inherit !important;
  line-height: inherit !important;
}
html {
  -webkit-font-smoothing: initial !important;
}
.v-btn.primary {
  color: #54585a !important;
}
.v-btn {
  text-transform: initial !important;
}
.v-text-field.v-text-field--solo .v-input__control {
  min-height: 35px !important;
}
</style>
<script>
import store from "@/store";
import router from "@/router";
import axios from "axios";
const axiosPFA = store.state.axiosPFA;
import querystring from "querystring";
import LoggedLayOut from "@/views/secure/LoggedLayOut.vue";
import Error401 from "@/views/errors/401.vue";
const serviceLocalStorage = store.state.serviceLocalStorage;
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-app",
  components: {
    LoggedLayOut,
    Error401,
  },
  data() {
    return {
      isLoading: false,
      isErrorAccess: false,
      isSwagger: true,
    };
  },
  computed: {
    isLogged() {
      return store.state.isLogged;
    },
  },
  methods: {
    registerSession(empleado) {
      axiosPFA
        .get("/session/register/" + empleado)
        .then((response) => {
          if (!response.data.current_access) {
            console.log("Conflicto al registrar la sesion");
            //store.state.dialogSessionFinish = true;
          } else {
            store.state.dialogSessionFinish = false;
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    getNewToken(empleado) {
      const self = this;
      const options = {
        method: "POST",
        data: querystring.stringify({
          username: empleado,
          password: empleado,
          grant_type: "password",
        }),
        headers: {
          "content-type": "application/x-www-form-urlencoded;charset=utf-8",
        },
        auth: {
          username: "frontendapp",
          password: "12345",
        },
        url: "/security/oauth/token",
      };
      this.isLoading = true;
      axios
        .request(options)
        .then((response) => {
          if (response && response.status === 200) {
            let response_token = response.data;
            if (
              response_token.status_code &&
              response_token.status_code == 401
            ) {
              self.isErrorAccess = true;
            } else {
              serviceLocalStorage.setToken(response_token);
              if (store.state.production) {
                self.registerSession(empleado);
              }
              store.state.isLogged = true;
              store.state.dialogSessionFinish = false;
              router.push({ name: "home" });
              self.deleteCookie("user");
            }
          } else {
            self.isErrorAccess = true;
          }
        })
        .catch((error) => {
          self.isErrorAccess = true;
          self.isLoading = false;
          console.log(error);
        })
        .finally(function() {
          self.isLoading = false;
        });
    },
    getCookie(cname) {
      return serviceCommons.getCookie(cname);
    },
    setCookie(cname, cvalue, exdays) {
      serviceCommons.setCookie(cname, cvalue, exdays);
    },
    deleteCookie(cname) {
      serviceCommons.deleteCookie(cname);
    },
  },
  created() {
    if (window.location.href.includes("swagger-ui")) {
      this.isSwagger = true;
    } else {
      this.isSwagger = false;
    }
    const loginSaml = serviceCommons.getCookie("login_saml");
    store.state.isLoginSaml =
      loginSaml !== undefined && loginSaml !== "" && loginSaml !== "null";
    if (store.state.isLoginSaml) {
      const noEmpleado = this.getCookie("user");
      if (noEmpleado && noEmpleado !== "" && noEmpleado !== "null") {
        this.getNewToken(noEmpleado);
      }
    }
    let accessToken = serviceLocalStorage.getAccessToken();
    let route = location.href;
    if (route.includes("maquetado")) {
      const fake_token = {
        access_token:
          "eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJjZWNvIjoyNjY4OTUsImVtcGxlYWRvIjoyMDI2MjIsInVzZXJfbmFtZSI6IjIwMjYyMiIsInNjb3BlIjpbInJlYWQiLCJ3cml0ZSJdLCJleHAiOjE1ODYyODY3NzksIm5vbWJyZSI6IkNBUkxPUyBBTlRPTklPIEVTQ09CQVIgSEVSTkFOREVaIiwianRpIjoiMzAxNjI1MjgtOGNlOC00NmJkLTlmZWQtMGUwNjFjYjNjMDg2IiwiY2xpZW50X2lkIjoiZnJvbnRlbmRhcHAifQ.t8XAFtgu06i9p0hZQN5bzEmmiLHyJUmQ3t33j7iGmBA",
        token_type: "bearer",
        refresh_token:
          "eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJjZWNvIjoyNjY4OTUsImVtcGxlYWRvIjoyMDI2MjIsInVzZXJfbmFtZSI6IjIwMjYyMiIsInNjb3BlIjpbInJlYWQiLCJ3cml0ZSJdLCJhdGkiOiIzMDE2MjUyOC04Y2U4LTQ2YmQtOWZlZC0wZTA2MWNiM2MwODYiLCJleHAiOjE1ODYzNjU5NzksIm5vbWJyZSI6IkNBUkxPUyBBTlRPTklPIEVTQ09CQVIgSEVSTkFOREVaIiwianRpIjoiM2Y3NzNmNTMtMjQyMy00MGVmLTkzMDctNGQwYmEzYzZlMjBmIiwiY2xpZW50X2lkIjoiZnJvbnRlbmRhcHAifQ.dZqvbb979DdC-4DrqmDy1HPSCeYi0kM3AjKL1ewKR3E",
        expires_in: 7199,
        scope: "read write",
        ceco: 266895,
        empleado: 202622,
        nombre: "CARLOS ANTONIO ESCOBAR HERNANDEZ",
        jti: "30162528-8ce8-46bd-9fed-0e061cb3c086",
      };
      serviceLocalStorage.setToken(fake_token);
      accessToken = fake_token.access_token;
    }
    if (accessToken) {
      store.state.isLogged = true;
    } else {
      router.push({ name: "login_alternative" });
    }
  },
};
</script>
